program Comp;
{$B-}{$M 30000, 6000}
{$I+,R+,S+,Q+}
{$D A Pascal-Compiler for the Masses}

{Grammar for Borland Delphi 1.0}
{compile with Delphi 1.0}

uses WinCrt,
  SysUtils,
  PARSER in 'PARSER.PAS',
  SCANNER in 'SCANNER.PAS',
  LEXLIB in 'LEXLIB.PAS',
  YACCLIB in 'YACCLIB.PAS',
  ERRORS in 'ERRORS.PAS',
  Scanlifo in 'SCANLIFO.PAS',
  Scanstack in 'SCANSTAC.PAS';

var f: TextFile;
    zeit : Extended;
type TBuf = array[1..10240] of char;
var Buf : ^TBuf;

begin
  ScreenSize.y := 20;
  ScreenSize.x := 75;
  Writeln('Parser Template for Borland-Delphi 1.0 Source Files!');
  Writeln('  Usage: Delparse.exe Sourcefile.pas');
  Writeln;
  if ParamStr(2) <> '' then begin
    AssignFile(Output, ParamStr(2));
    Rewrite(Output);
    New( Buf );
    SetTextBuf( Output, Buf );
  end;

  {run the parse}
  Parser.Run_Parse;

  CloseFile(Output);
end.

