unit Scanlifo;
{ $I vorein~1.inc}
                 
interface
uses SysUtils;

type TLiFoItems = word;

     ELiFO = class( Exception );

procedure Create( Size : word );
procedure Destroy;

procedure LiFoIn( Item: TLiFoItems );
function  LiFoOut: TLiFoItems;

implementation
{$R-}
type PLiFoStack = ^TLiFoStack;
     TLiFoStack = array[ 1..1 ] of TLiFoItems;
const LiFoStack : PLiFoStack = nil;
      LiFoSize : word = 0; {allozierte Gre des LiFo}
      LiFoAkt : word = 0; {zeigt auf freies Element;
                           ist grer als LiFoSize, wenn voll; oder 0, wenn leer}

procedure Create( Size : word );
begin
  if LiFoStack <> nil then
    raise ELiFo.Create( 'LiFo-Stack ist bereits initialisiert!' );
  LiFoSize := Size;
  GetMem( LiFoStack, SizeOf( TLiFoItems ) * Size );
  LiFoSize := Size;
  LiFoAkt := 1;
end;

procedure Destroy;
begin
  FreeMem( LiFoStack, SizeOf( TLiFoItems ) * LiFoSize );
  LiFoStack := nil;
  LiFoSize := 0;
  LiFoAkt := 0;
end;


procedure LiFoIn( Item: TLiFoItems );
begin
  if LiFoStack = nil then
    raise ELiFo.Create( 'LiFo-Stack ist nicht initialisiert!');
  if LiFoAkt > LiFoSize then
    raise ELiFo.Create( 'LiFo-Stack ist bereits voll!');
  LiFoStack^[ LiFoAkt ] := Item;
  LiFoAkt := LiFoAkt + 1;
end;

function  LiFoOut: TLiFoItems;
begin
  if LiFoStack = nil then
    raise ELiFo.Create( 'LiFo-Stack ist nicht initialisiert!');
  if LiFoAkt < 2 then
    raise ELiFo.Create( 'LiFo-Stack ist leer!');
  Result := LiFoStack^[ LiFoAkt - 1 ];
  LiFoAkt := LiFoAkt - 1;
end;


{initialization}
end.
