unit Scanstack;

interface

procedure SwitchState( old, new: integer );
procedure Return2OldState;
function FormerState: integer;

implementation
uses SysUtils, ScanLiFo, LexLib;

procedure SwitchState( old, new: integer );
begin
  ScanLiFo.LiFoIn( old );
  Start( new );
end;

procedure Return2OldState;
begin
  Start( ScanLiFo.LiFoOut );
end;

function FormerState: integer;
begin
  Result := ScanLiFo.LiFoOut;
  ScanLiFo.LiFoIn( Result );
end;

{*************************************************************}
procedure DoExit; far;
begin
  ScanLiFo.Destroy;
end;

initialization
  ScanLiFo.Create( 5 );
  AddExitProc( DoExit );
end.
