
(* Yacc parser template (TP Yacc V3.0), V1.2 6-17-91 AG *)

(* global definitions: *)

{$define ErrorRecovery}

{$undef yydebug}
{$undef yyExternTables}
{$define yyResourceTables}
{$undef yyLargeTables}

(*
 *
 *)
{$D-,L-,Y-}
unit Parser;{$B-}

interface
uses LexLib, YaccLib;

procedure Run_Parse;

const _AND_ = 257;
const _AS_ = 258;
const _ASM_ = 259;
const _ARRAY_ = 260;
const _BEGIN_ = 261;
const _CASE_ = 262;
const _CLASS_ = 263;
const _CONST_ = 264;
const _CONSTRUCTOR_ = 265;
const _DESTRUCTOR_ = 266;
const _DIV_ = 267;
const _DO_ = 268;
const _DOWNTO_ = 269;
const _ELSE_ = 270;
const _END_ = 271;
const _EXCEPT_ = 272;
const _EXPORTS_ = 273;
const _FILE_ = 274;
const _FINALLY_ = 275;
const _FOR_ = 276;
const _FUNCTION_ = 277;
const _GOTO_ = 278;
const _IF_ = 279;
const _IMPLEMENTATION_ = 280;
const _IN_ = 281;
const _INHERITED_ = 282;
const _INLINE_ = 283;
const _INITIALIZATION_ = 284;
const _INTERFACE_ = 285;
const _IS_ = 286;
const _LABEL_ = 287;
const _LIBRARY_ = 288;
const _MOD_ = 289;
const _NIL_ = 290;
const _NOT_ = 291;
const _OBJECT_ = 292;
const _OF_ = 293;
const _OR_ = 294;
const _PACKED_ = 295;
const _PROCEDURE_ = 296;
const _PROGRAM_ = 297;
const _PROPERTY_ = 298;
const _RAISE_ = 299;
const _RECORD_ = 300;
const _REPEAT_ = 301;
const _SET_ = 302;
const _SHL_ = 303;
const _SHR_ = 304;
const _STRING_ = 305;
const _THEN_ = 306;
const _TO_ = 307;
const _TRY_ = 308;
const _TYPE_ = 309;
const _UNIT_ = 310;
const _UNTIL_ = 311;
const _USES_ = 312;
const _VAR_ = 313;
const _WHILE_ = 314;
const _WITH_ = 315;
const _XOR_ = 316;
const _ABSOLUTE_ = 317;
const _ABSTRACT_ = 318;
const _ASSEMBLER_ = 319;
const _AT_ = 320;
const _CDECL_ = 321;
const _DEFAULT_ = 322;
const _DYNAMIC_ = 323;
const _EXPORT_ = 324;
const _EXTERNAL_ = 325;
const _FAR_ = 326;
const _FORWARD_ = 327;
const _INDEX_ = 328;
const _INTERRUPT_ = 329;
const _MESSAGE_ = 330;
const _NAME_ = 331;
const _NEAR_ = 332;
const _NODEFAULT_ = 333;
const _ON_ = 334;
const _OVERRIDE_ = 335;
const _PRIVATE_ = 336;
const _PROTECTED_ = 337;
const _PUBLIC_ = 338;
const _PUBLISHED_ = 339;
const _READ_ = 340;
const _RESIDENT_ = 341;
const _STORED_ = 342;
const _VIRTUAL_ = 343;
const _WRITE_ = 344;
const _ASSIGNMENT_ = 345;
const DOTDOT = 346;
const GE = 347;
const LE = 348;
const NOTEQUAL = 349;
const STARSTAR = 350;
const IDENTIFIER = 351;
const IMMCHAR_ID = 352;
const COLON = 353;
const COMMA = 354;
const DOT = 355;
const EQUAL = 356;
const GT = 357;
const LBRAC = 358;
const LPAREN = 359;
const LT = 360;
const MINUS = 361;
const PLUS = 362;
const RBRAC = 363;
const RPAREN = 364;
const SEMICOLON = 365;
const SLASH = 366;
const STAR = 367;
const UPARROW = 368;
const APE_SYMBOL = 369;
const ILLEGAL = 370;
const ET = 371;
const ASM_LABEL = 372;
const ASM_SEPERATOR = 373;
const ASM_REGISTER = 374;
const ASM_OPCODE = 375;
const ASM_DIRECTIVE = 376;
const UNSIGNED_INTEGER = 377;
const UNSIGNED_REAL = 378;
const STRING_CONST = 379;

type YYSType = record case Integer of
                 1 : ( yyExtended : Extended );
                 2 : ( yyLongint : Longint );
                 3 : ( yyPString : PString );
               end(*YYSType*);
function WouldAcceptChar(sym: integer):boolean;

var filename : String;

var yylval : YYSType;

{$ifdef yyLargeTables}  {Large Tables}
  #
{$else}{$ifdef yyResourceTables}  {Tables in Ressource}
{$R *.res}
{$else}{$ifdef yyExternTables}  {Extern Tables}
{$else}  {Normal Tables}
{$endif}{$endif}{$endif}

implementation
uses SysUtils, Forms,
     Scanner {fr function yylex : Integer; forward;}, ScanStack
{$ifdef yyLargeTables}  {Large Tables}
  #
{$else}{$ifdef yyResourceTables}  {Tables in Ressource}
      , WinTypes, WinProcs, Classes
{$else}{$ifdef yyExternTables}  {Extern Tables}
      , Classes
{$else}  {Normal Tables}

{$endif}{$endif}{$endif}
     ;

procedure yyerror(msg : string);
  begin
    writeln(filename, ': ', yylineno, ': ', yycolno, ': ',
            msg, ' at or before `', yytext, '''.')
  end(*yyerror*);

{function yyparse : Integer;}

type Tyys = array [1..yymaxdepth] of Integer;
     Tyyv = array [1..yymaxdepth] of YYSType;
var yystate, yysp, yyn : Integer;
    yyval : YYSType;
const yys : ^Tyys = nil;
      yyv : ^Tyyv = nil;

procedure yyaction ( yyruleno : Integer );
  (* local definitions: *)
begin
  (* actions: *)
  case yyruleno of
   1 : begin
         writeln('erkannt:program_file');
       end;
   2 : begin
         
       end;
   3 : begin
         
       end;
   4 : begin
         
       end;
   5 : begin
         
       end;
   6 : begin
         
       end;
   7 : begin
         
       end;
   8 : begin
         
       end;
   9 : begin
         
       end;
  10 : begin
         
       end;
  11 : begin
         
       end;
  12 : begin
         
       end;
  13 : begin
         
       end;
  14 : begin
         
       end;
  15 : begin
         
       end;
  16 : begin
         
       end;
  17 : begin
         
       end;
  18 : begin
         
       end;
  19 : begin
         
       end;
  20 : begin
         
       end;
  21 : begin
         
       end;
  22 : begin
         
       end;
  23 : begin
         
       end;
  24 : begin
         
       end;
  25 : begin
         
       end;
  26 : begin
         
       end;
  27 : begin
         
       end;
  28 : begin
         
       end;
  29 : begin
         
       end;
  30 : begin
         
       end;
  31 : begin
         
       end;
  32 : begin
         
       end;
  33 : begin
         
       end;
  34 : begin
         
       end;
  35 : begin
         
       end;
  36 : begin
         
       end;
  37 : begin
         
       end;
  38 : begin
         
       end;
  39 : begin
         
       end;
  40 : begin
         
       end;
  41 : begin
         
       end;
  42 : begin
         
       end;
  43 : begin
         yyval := yyv^[yysp-0];
       end;
  44 : begin
         
       end;
  45 : begin
         
       end;
  46 : begin
         
       end;
  47 : begin
         
       end;
  48 : begin
         
       end;
  49 : begin
         
       end;
  50 : begin
         
       end;
  51 : begin
         writeln('erk: prog ');
       end;
  52 : begin
         
       end;
  53 : begin
         
       end;
  54 : begin
         
       end;
  55 : begin
         
       end;
  56 : begin
         
       end;
  57 : begin
         
       end;
  58 : begin
         
       end;
  59 : begin
         
       end;
  60 : begin
         
       end;
  61 : begin
         
       end;
  62 : begin
         
       end;
  63 : begin
         
       end;
  64 : begin
         
       end;
  65 : begin
         
       end;
  66 : begin
         
       end;
  67 : begin
         
       end;
  68 : begin
         
       end;
  69 : begin
         
       end;
  70 : begin
         
       end;
  71 : begin
         
       end;
  72 : begin
         
       end;
  73 : begin
         
       end;
  74 : begin
         
       end;
  75 : begin
         
       end;
  76 : begin
         
       end;
  77 : begin
         
       end;
  78 : begin
         
       end;
  79 : begin
         
       end;
  80 : begin
         
       end;
  81 : begin
         
       end;
  82 : begin
         
       end;
  83 : begin
         
       end;
  84 : begin
         
       end;
  85 : begin
         
       end;
  86 : begin
         
       end;
  87 : begin
         
       end;
  88 : begin
         
       end;
  89 : begin
         
       end;
  90 : begin
         
       end;
  91 : begin
         
       end;
  92 : begin
         
       end;
  93 : begin
         
       end;
  94 : begin
         
       end;
  95 : begin
         
       end;
  96 : begin
         
       end;
  97 : begin
         
       end;
  98 : begin
         
       end;
  99 : begin
         
       end;
 100 : begin
         
       end;
 101 : begin
         
       end;
 102 : begin
         
       end;
 103 : begin
         
       end;
 104 : begin
         
       end;
 105 : begin
         
       end;
 106 : begin
         
       end;
 107 : begin
         
       end;
 108 : begin
         
       end;
 109 : begin
         
       end;
 110 : begin
         
       end;
 111 : begin
         
       end;
 112 : begin
         
       end;
 113 : begin
         
       end;
 114 : begin
         
       end;
 115 : begin
         
       end;
 116 : begin
         
       end;
 117 : begin
         
       end;
 118 : begin
         
       end;
 119 : begin
         
       end;
 120 : begin
         
       end;
 121 : begin
         
       end;
 122 : begin
         
       end;
 123 : begin
         
       end;
 124 : begin
         
       end;
 125 : begin
         
       end;
 126 : begin
         
       end;
 127 : begin
         
       end;
 128 : begin
         
       end;
 129 : begin
         
       end;
 130 : begin
         
       end;
 131 : begin
         
       end;
 132 : begin
         
       end;
 133 : begin
         
       end;
 134 : begin
         
       end;
 135 : begin
         
       end;
 136 : begin
         yyval := yyv^[yysp-1];
       end;
 137 : begin
         
       end;
 138 : begin
         
       end;
 139 : begin
         
       end;
 140 : begin
         
       end;
 141 : begin
         
       end;
 142 : begin
         
       end;
 143 : begin
         
       end;
 144 : begin
         
       end;
 145 : begin
         
       end;
 146 : begin
         
       end;
 147 : begin
         
       end;
 148 : begin
         
       end;
 149 : begin
         
       end;
 150 : begin
         
       end;
 151 : begin
         
       end;
 152 : begin
         
       end;
 153 : begin
         
       end;
 154 : begin
         
       end;
 155 : begin
         
       end;
 156 : begin
         
       end;
 157 : begin
         
       end;
 158 : begin
         
       end;
 159 : begin
         
       end;
 160 : begin
         
       end;
 161 : begin
         
       end;
 162 : begin
         
       end;
 163 : begin
         
       end;
 164 : begin
         
       end;
 165 : begin
         
       end;
 166 : begin
         
       end;
 167 : begin
         
       end;
 168 : begin
         
       end;
 169 : begin
         
       end;
 170 : begin
         
       end;
 171 : begin
         
       end;
 172 : begin
         
       end;
 173 : begin
         
       end;
 174 : begin
         
       end;
 175 : begin
         
       end;
 176 : begin
         
       end;
 177 : begin
         
       end;
 178 : begin
         
       end;
 179 : begin
         
       end;
 180 : begin
         
       end;
 181 : begin
         
       end;
 182 : begin
         
       end;
 183 : begin
         
       end;
 184 : begin
         
       end;
 185 : begin
         
       end;
 186 : begin
         
       end;
 187 : begin
         
       end;
 188 : begin
         
       end;
 189 : begin
         
       end;
 190 : begin
         
       end;
 191 : begin
         
       end;
 192 : begin
         
       end;
 193 : begin
         
       end;
 194 : begin
         
       end;
 195 : begin
         
       end;
 196 : begin
         
       end;
 197 : begin
         
       end;
 198 : begin
         
       end;
 199 : begin
         
       end;
 200 : begin
         
       end;
 201 : begin
         
       end;
 202 : begin
         
       end;
 203 : begin
         
       end;
 204 : begin
         
       end;
 205 : begin
         
       end;
 206 : begin
         
       end;
 207 : begin
         
       end;
 208 : begin
         
       end;
 209 : begin
         
       end;
 210 : begin
         
       end;
 211 : begin
         
       end;
 212 : begin
         
       end;
 213 : begin
         
       end;
 214 : begin
         
       end;
 215 : begin
         
       end;
 216 : begin
         
       end;
 217 : begin
         
       end;
 218 : begin
         
       end;
 219 : begin
         
       end;
 220 : begin
         
       end;
 221 : begin
         
       end;
 222 : begin
         
       end;
 223 : begin
         
       end;
 224 : begin
         
       end;
 225 : begin
         
       end;
 226 : begin
         
       end;
 227 : begin
         
       end;
 228 : begin
         
       end;
 229 : begin
         
       end;
 230 : begin
         
       end;
 231 : begin
         
       end;
 232 : begin
         
       end;
 233 : begin
         
       end;
 234 : begin
         
       end;
 235 : begin
         
       end;
 236 : begin
         
       end;
 237 : begin
         
       end;
 238 : begin
         
       end;
 239 : begin
         
       end;
 240 : begin
         
       end;
 241 : begin
         
       end;
 242 : begin
         
       end;
 243 : begin
         
       end;
 244 : begin
         
       end;
 245 : begin
         
       end;
 246 : begin
         
       end;
 247 : begin
         
       end;
 248 : begin
         
       end;
 249 : begin
         
       end;
 250 : begin
         
       end;
 251 : begin
         
       end;
 252 : begin
         
       end;
 253 : begin
         
       end;
 254 : begin
         
       end;
 255 : begin
         
       end;
 256 : begin
         
       end;
 257 : begin
         
       end;
 258 : begin
         
       end;
 259 : begin
         
       end;
 260 : begin
         
       end;
 261 : begin
         
       end;
 262 : begin
         
       end;
 263 : begin
         
       end;
 264 : begin
         
       end;
 265 : begin
         
       end;
 266 : begin
         
       end;
 267 : begin
         
       end;
 268 : begin
         
       end;
 269 : begin
         
       end;
 270 : begin
         
       end;
 271 : begin
         
       end;
 272 : begin
         
       end;
 273 : begin
         
       end;
 274 : begin
         
       end;
 275 : begin
         
       end;
 276 : begin
         
       end;
 277 : begin
         
       end;
 278 : begin
         
       end;
 279 : begin
         
       end;
 280 : begin
         
       end;
 281 : begin
         
       end;
 282 : begin
         
       end;
 283 : begin
         
       end;
 284 : begin
         
       end;
 285 : begin
         
       end;
 286 : begin
         
       end;
 287 : begin
         
       end;
 288 : begin
         
       end;
 289 : begin
         
       end;
 290 : begin
         
       end;
 291 : begin
         
       end;
 292 : begin
         
       end;
 293 : begin
         
       end;
 294 : begin
         
       end;
 295 : begin
         
       end;
 296 : begin
         
       end;
 297 : begin
         
       end;
 298 : begin
         
       end;
 299 : begin
         
       end;
 300 : begin
         
       end;
 301 : begin
         
       end;
 302 : begin
         
       end;
 303 : begin
         
       end;
 304 : begin
         
       end;
 305 : begin
         
       end;
 306 : begin
         
       end;
 307 : begin
         
       end;
 308 : begin
         
       end;
 309 : begin
         
       end;
 310 : begin
         
       end;
 311 : begin
         
       end;
 312 : begin
         
       end;
 313 : begin
         
       end;
 314 : begin
         
       end;
 315 : begin
         
       end;
 316 : begin
         
       end;
 317 : begin
         
       end;
 318 : begin
         
       end;
 319 : begin
         
       end;
 320 : begin
         
       end;
 321 : begin
         
       end;
 322 : begin
         
       end;
 323 : begin
         
       end;
 324 : begin
         
       end;
 325 : begin
         
       end;
 326 : begin
         
       end;
 327 : begin
         
       end;
 328 : begin
         
       end;
 329 : begin
         
       end;
 330 : begin
         
       end;
 331 : begin
         
       end;
 332 : begin
         
       end;
 333 : begin
         
       end;
 334 : begin
         
       end;
 335 : begin
         
       end;
 336 : begin
         
       end;
 337 : begin
         
       end;
 338 : begin
         
       end;
 339 : begin
         
       end;
 340 : begin
         
       end;
 341 : begin
         
       end;
 342 : begin
         
       end;
 343 : begin
         
       end;
 344 : begin
         
       end;
 345 : begin
         
       end;
 346 : begin
         
       end;
 347 : begin
         
       end;
 348 : begin
         
       end;
 349 : begin
         
       end;
 350 : begin
         
       end;
 351 : begin
         
       end;
 352 : begin
         
       end;
 353 : begin
         
       end;
 354 : begin
         
       end;
 355 : begin
         
       end;
 356 : begin
         
       end;
 357 : begin
         
       end;
 358 : begin
         
       end;
 359 : begin
         
       end;
 360 : begin
         
       end;
 361 : begin
         
       end;
 362 : begin
         
       end;
 363 : begin
         
       end;
 364 : begin
         
       end;
 365 : begin
         
       end;
 366 : begin
         
       end;
 367 : begin
         
       end;
 368 : begin
         
       end;
 369 : begin
         
       end;
 370 : begin
         
       end;
 371 : begin
         
       end;
 372 : begin
         
       end;
 373 : begin
         
       end;
 374 : begin
         
       end;
 375 : begin
         
       end;
 376 : begin
         
       end;
 377 : begin
         
       end;
 378 : begin
         
       end;
 379 : begin
         
       end;
 380 : begin
         
       end;
 381 : begin
         
       end;
 382 : begin
         
       end;
 383 : begin
         
       end;
 384 : begin
         
       end;
 385 : begin
         
       end;
 386 : begin
         
       end;
 387 : begin
         
       end;
 388 : begin
         
       end;
 389 : begin
         
       end;
 390 : begin
         
       end;
 391 : begin
         
       end;
 392 : begin
         
       end;
 393 : begin
         
       end;
 394 : begin
         
       end;
 395 : begin
         
       end;
 396 : begin
         
       end;
 397 : begin
         
       end;
 398 : begin
         
       end;
 399 : begin
         
       end;
 400 : begin
         
       end;
 401 : begin
         
       end;
 402 : begin
         
       end;
 403 : begin
         
       end;
 404 : begin
         
       end;
 405 : begin
         
       end;
 406 : begin
         
       end;
 407 : begin
         
       end;
 408 : begin
         
       end;
 409 : begin
         
       end;
 410 : begin
         
       end;
 411 : begin
         
       end;
 412 : begin
         
       end;
 413 : begin
         yyval := yyv^[yysp-0];
       end;
 414 : begin
         
       end;
 415 : begin
         
       end;
 416 : begin
         
       end;
 417 : begin
         
       end;
 418 : begin
         
       end;
 419 : begin
         
       end;
 420 : begin
         
       end;
 421 : begin
         
       end;
 422 : begin
         
       end;
 423 : begin
         
       end;
 424 : begin
         
       end;
 425 : begin
         
       end;
 426 : begin
         
       end;
 427 : begin
         
       end;
 428 : begin
         
       end;
 429 : begin
         
       end;
 430 : begin
         
       end;
 431 : begin
         
       end;
 432 : begin
         
       end;
 433 : begin
         
       end;
 434 : begin
         
       end;
 435 : begin
         
       end;
 436 : begin
         
       end;
 437 : begin
         
       end;
 438 : begin
         
       end;
 439 : begin
         
       end;
 440 : begin
         
       end;
 441 : begin
         
       end;
 442 : begin
         
       end;
 443 : begin
         
       end;
 444 : begin
         
       end;
 445 : begin
         
       end;
 446 : begin
         
       end;
 447 : begin
         
       end;
 448 : begin
         
       end;
 449 : begin
         
       end;
 450 : begin
         
       end;
 451 : begin
         
       end;
 452 : begin
         
       end;
 453 : begin
         
       end;
 454 : begin
         
       end;
 455 : begin
         
       end;
 456 : begin
         
       end;
 457 : begin
         
       end;
 458 : begin
         
       end;
 459 : begin
         
       end;
 460 : begin
         
       end;
 461 : begin
         
       end;
 462 : begin
         
       end;
 463 : begin
         
       end;
 464 : begin
         
       end;
 465 : begin
         
       end;
 466 : begin
         
       end;
 467 : begin
         
       end;
 468 : begin
         
       end;
 469 : begin
         
       end;
 470 : begin
         
       end;
 471 : begin
         
       end;
 472 : begin
         
       end;
 473 : begin
         
       end;
 474 : begin
         
       end;
 475 : begin
         
       end;
 476 : begin
         
       end;
 477 : begin
         
       end;
 478 : begin
         
       end;
 479 : begin
         
       end;
 480 : begin
       end;
 481 : begin
         
       end;
 482 : begin
         
       end;
 483 : begin
         
       end;
 484 : begin
         
       end;
 485 : begin
         
       end;
 486 : begin
         
       end;
 487 : begin
         
       end;
 488 : begin
         
       end;
 489 : begin
         
       end;
 490 : begin
         
       end;
 491 : begin
         
       end;
 492 : begin
         
       end;
 493 : begin
         
       end;
 494 : begin
         
       end;
 495 : begin
         
       end;
 496 : begin
         
       end;
 497 : begin
         
       end;
 498 : begin
         
       end;
 499 : begin
         
       end;
 500 : begin
         
       end;
 501 : begin
         
       end;
 502 : begin
         
       end;
 503 : begin
         
       end;
 504 : begin
         
       end;
 505 : begin
         
       end;
 506 : begin
         
       end;
 507 : begin
         
       end;
 508 : begin
         
       end;
 509 : begin
         
       end;
 510 : begin
         
       end;
 511 : begin
         
       end;
 512 : begin
         
       end;
 513 : begin
         
       end;
 514 : begin
         
       end;
 515 : begin
         
       end;
 516 : begin
       end;
 517 : begin
         
       end;
 518 : begin
         
       end;
 519 : begin
         
       end;
 520 : begin
         
       end;
 521 : begin
         
       end;
 522 : begin
         
       end;
 523 : begin
         
       end;
 524 : begin
         
       end;
 525 : begin
         
       end;
 526 : begin
         
       end;
 527 : begin
         
       end;
 528 : begin
         
       end;
 529 : begin
         
       end;
 530 : begin
         
       end;
 531 : begin
         
       end;
 532 : begin
         
       end;
 533 : begin
         
       end;
 534 : begin
         
       end;
 535 : begin
         
       end;
 536 : begin
         
       end;
 537 : begin
         
       end;
 538 : begin
         
       end;
 539 : begin
         
       end;
 540 : begin
         
       end;
 541 : begin
         
       end;
 542 : begin
         
       end;
 543 : begin
         
       end;
 544 : begin
         
       end;
 545 : begin
         
       end;
 546 : begin
         
       end;
 547 : begin
         
       end;
 548 : begin
         
       end;
 549 : begin
         
       end;
 550 : begin
         
       end;
 551 : begin
         
       end;
 552 : begin
         
       end;
 553 : begin
         
       end;
 554 : begin
         
       end;
 555 : begin
         
       end;
 556 : begin
         
       end;
 557 : begin
         
       end;
 558 : begin
         
       end;
 559 : begin
         
       end;
 560 : begin
         
       end;
 561 : begin
         
       end;
 562 : begin
         
       end;
 563 : begin
         
       end;
 564 : begin
         
       end;
 565 : begin
         
       end;
 566 : begin
         
       end;
 567 : begin
         
       end;
 568 : begin
         
       end;
 569 : begin
         
       end;
 570 : begin
         
       end;
 571 : begin
         
       end;
 572 : begin
         
       end;
 573 : begin
         
       end;
 574 : begin
         
       end;
 575 : begin
         
       end;
 576 : begin
         
       end;
 577 : begin
         
       end;
 578 : begin
         
       end;
 579 : begin
         
       end;
 580 : begin
         
       end;
 581 : begin
         
       end;
 582 : begin
         
       end;
 583 : begin
         
       end;
 584 : begin
         
       end;
 585 : begin
         
       end;
 586 : begin
         
       end;
 587 : begin
         
       end;
 588 : begin
         
       end;
 589 : begin
         
       end;
 590 : begin
         
       end;
 591 : begin
         
       end;
 592 : begin
         
       end;
 593 : begin
         
       end;
 594 : begin
         
       end;
 595 : begin
         
       end;
 596 : begin
         
       end;
 597 : begin
         
       end;
 598 : begin
         
       end;
 599 : begin
         
       end;
 600 : begin
         
       end;
 601 : begin
         
       end;
 602 : begin
         
       end;
 603 : begin
         
       end;
 604 : begin
         
       end;
 605 : begin
         
       end;
 606 : begin
         
       end;
 607 : begin
         
       end;
 608 : begin
         
       end;
 609 : begin
         
       end;
 610 : begin
         
       end;
 611 : begin
         
       end;
 612 : begin
         
       end;
 613 : begin
         
       end;
 614 : begin
         
       end;
 615 : begin
         yyval := yyv^[yysp-0];
       end;
 616 : begin
         
       end;
 617 : begin
         
       end;
 618 : begin
         
       end;
 619 : begin
         
       end;
 620 : begin
         
       end;
 621 : begin
         
       end;
 622 : begin
         
       end;
 623 : begin
         
       end;
 624 : begin
         
       end;
 625 : begin
         
       end;
 626 : begin
         
       end;
 627 : begin
         
       end;
 628 : begin
         
       end;
 629 : begin
         
       end;
 630 : begin
         
       end;
 631 : begin
         
       end;
 632 : begin
         
       end;
 633 : begin
         
       end;
 634 : begin
         
       end;
 635 : begin
         
       end;
 636 : begin
         
       end;
 637 : begin
         
       end;
 638 : begin
         
       end;
 639 : begin
         
       end;
 640 : begin
         
       end;
 641 : begin
         
       end;
 642 : begin
         
       end;
 643 : begin
         
       end;
 644 : begin
         
       end;
 645 : begin
         
       end;
 646 : begin
         
       end;
 647 : begin
         
       end;
 648 : begin
         
       end;
 649 : begin
         
       end;
 650 : begin
         
       end;
 651 : begin
         
       end;
 652 : begin
         
       end;
 653 : begin
         
       end;
 654 : begin
         
       end;
 655 : begin
         
       end;
 656 : begin
         
       end;
 657 : begin
         
       end;
 658 : begin
         
       end;
 659 : begin
         
       end;
 660 : begin
         
       end;
 661 : begin
         
       end;
 662 : begin
         
       end;
 663 : begin
         
       end;
 664 : begin
         
       end;
 665 : begin
         
       end;
 666 : begin
         
       end;
 667 : begin
         
       end;
 668 : begin
         
       end;
 669 : begin
         
       end;
 670 : begin
         
       end;
 671 : begin
         
       end;
 672 : begin
         
       end;
 673 : begin
         
       end;
 674 : begin
         
       end;
 675 : begin
         
       end;
 676 : begin
         
       end;
 677 : begin
         
       end;
 678 : begin
         
       end;
 679 : begin
         
       end;
 680 : begin
         
       end;
 681 : begin
         
       end;
 682 : begin
         
       end;
 683 : begin
         
       end;
 684 : begin
         
       end;
 685 : begin
         
       end;
 686 : begin
         
       end;
 687 : begin
         
       end;
 688 : begin
         
       end;
 689 : begin
         
       end;
 690 : begin
         
       end;
 691 : begin
         
       end;
 692 : begin
         
       end;
 693 : begin
         
       end;
 694 : begin
         
       end;
 695 : begin
         
       end;
 696 : begin
         
       end;
 697 : begin
         
       end;
 698 : begin
         
       end;
 699 : begin
         
       end;
 700 : begin
         
       end;
 701 : begin
         
       end;
 702 : begin
         
       end;
 703 : begin
         
       end;
 704 : begin
         
       end;
 705 : begin
         
       end;
 706 : begin
         
       end;
 707 : begin
         
       end;
 708 : begin
         
       end;
 709 : begin
         
       end;
 710 : begin
         
       end;
 711 : begin
         
       end;
 712 : begin
         
       end;
 713 : begin
         
       end;
 714 : begin
         
       end;
 715 : begin
         
       end;
 716 : begin
         
       end;
 717 : begin
         
       end;
 718 : begin
         
       end;
 719 : begin
         
       end;
 720 : begin
         
       end;
 721 : begin
         
       end;
 722 : begin
         
       end;
 723 : begin
         
       end;
 724 : begin
         
       end;
 725 : begin
         
       end;
 726 : begin
         
       end;
 727 : begin
         
       end;
 728 : begin
         
       end;
 729 : begin
         
       end;
 730 : begin
         
       end;
 731 : begin
         
       end;
 732 : begin
         
       end;
 733 : begin
         
       end;
 734 : begin
         
       end;
 735 : begin
         
       end;
 736 : begin
         
       end;
 737 : begin
         
       end;
 738 : begin
         
       end;
 739 : begin
         
       end;
 740 : begin
         
       end;
 741 : begin
         
       end;
 742 : begin
         
       end;
 743 : begin
         yyval := yyv^[yysp-4];
       end;
 744 : begin
         
       end;
 745 : begin
         
       end;
 746 : begin
         
       end;
 747 : begin
         
       end;
 748 : begin
         
       end;
 749 : begin
         
       end;
 750 : begin
         
       end;
 751 : begin
         
       end;
 752 : begin
         
       end;
 753 : begin
         
       end;
 754 : begin
         
       end;
 755 : begin
         
       end;
 756 : begin
         
       end;
 757 : begin
         
       end;
 758 : begin
         
       end;
 759 : begin
         
       end;
 760 : begin
         
       end;
 761 : begin
         
       end;
 762 : begin
         
       end;
 763 : begin
         
       end;
 764 : begin
         
       end;
 765 : begin
         
       end;
 766 : begin
         
       end;
 767 : begin
         
       end;
 768 : begin
         
       end;
 769 : begin
         
       end;
 770 : begin
         
       end;
 771 : begin
         
       end;
 772 : begin
         
       end;
 773 : begin
         
       end;
 774 : begin
         
       end;
 775 : begin
         
       end;
 776 : begin
         
       end;
 777 : begin
         
       end;
 778 : begin
         
       end;
 779 : begin
         
       end;
 780 : begin
         
       end;
 781 : begin
         
       end;
 782 : begin
         
       end;
 783 : begin
         
       end;
 784 : begin
         
       end;
 785 : begin
         
       end;
 786 : begin
         
       end;
 787 : begin
         
       end;
 788 : begin
         
       end;
 789 : begin
         
       end;
 790 : begin
         
       end;
 791 : begin
         
       end;
 792 : begin
         
       end;
 793 : begin
         
       end;
 794 : begin
         
       end;
 795 : begin
         
       end;
 796 : begin
         
       end;
 797 : begin
         
       end;
 798 : begin
         
       end;
 799 : begin
         
       end;
 800 : begin
         
       end;
 801 : begin
         
       end;
 802 : begin
         
       end;
 803 : begin
         
       end;
 804 : begin
         
       end;
 805 : begin
         
       end;
 806 : begin
         
       end;
 807 : begin
         
       end;
 808 : begin
         
       end;
 809 : begin
         
       end;
 810 : begin
         
       end;
 811 : begin
         
       end;
 812 : begin
         
       end;
 813 : begin
         
       end;
 814 : begin
         
       end;
 815 : begin
         
       end;
 816 : begin
         
       end;
 817 : begin
         
       end;
 818 : begin
         
       end;
 819 : begin
         
       end;
 820 : begin
         
       end;
 821 : begin
         
       end;
 822 : begin
         
       end;
 823 : begin
         
       end;
 824 : begin
         
       end;
 825 : begin
         
       end;
 826 : begin
         
       end;
 827 : begin
         
       end;
 828 : begin
         
       end;
 829 : begin
         
       end;
 830 : begin
         
       end;
 831 : begin
         
       end;
 832 : begin
         
       end;
 833 : begin
         
       end;
 834 : begin
         
       end;
 835 : begin
         
       end;
 836 : begin
         
       end;
 837 : begin
         
       end;
 838 : begin
         
       end;
 839 : begin
         
       end;
 840 : begin
         
       end;
 841 : begin
         
       end;
 842 : begin
         
       end;
 843 : begin
         
       end;
 844 : begin
         
       end;
 845 : begin
         
       end;
 846 : begin
         
       end;
 847 : begin
         
       end;
 848 : begin
         
       end;
 849 : begin
         
       end;
 850 : begin
         
       end;
 851 : begin
         
       end;
 852 : begin
         
       end;
 853 : begin
         
       end;
 854 : begin
         
       end;
 855 : begin
         
       end;
 856 : begin
         
       end;
 857 : begin
         
       end;
 858 : begin
         
       end;
 859 : begin
         
       end;
 860 : begin
         
       end;
 861 : begin
         
       end;
 862 : begin
         
       end;
 863 : begin
         
       end;
 864 : begin
         
       end;
 865 : begin
         
       end;
 866 : begin
         
       end;
 867 : begin
         
       end;
 868 : begin
         
       end;
 869 : begin
         
       end;
 870 : begin
         
       end;
 871 : begin
         
       end;
 872 : begin
         
       end;
 873 : begin
         
       end;
 874 : begin
         
       end;
 875 : begin
         
       end;
 876 : begin
         
       end;
 877 : begin
         
       end;
 878 : begin
         
       end;
 879 : begin
         
       end;
 880 : begin
         
       end;
 881 : begin
         
       end;
 882 : begin
         
       end;
 883 : begin
         
       end;
 884 : begin
         
       end;
 885 : begin
         
       end;
 886 : begin
         
       end;
 887 : begin
         
       end;
 888 : begin
         
       end;
 889 : begin
         
       end;
 890 : begin
         
       end;
 891 : begin
         
       end;
 892 : begin
         
       end;
 893 : begin
         
       end;
 894 : begin
         
       end;
 895 : begin
         
       end;
 896 : begin
         
       end;
 897 : begin
         
       end;
 898 : begin
         
       end;
 899 : begin
         
       end;
 900 : begin
         
       end;
 901 : begin
         
       end;
 902 : begin
         
       end;
 903 : begin
         
       end;
 904 : begin
         
       end;
 905 : begin
         
       end;
 906 : begin
         
       end;
 907 : begin
         
       end;
 908 : begin
         
       end;
 909 : begin
         
       end;
 910 : begin
         
       end;
 911 : begin
         
       end;
 912 : begin
         
       end;
 913 : begin
         
       end;
 914 : begin
         
       end;
 915 : begin
         
       end;
 916 : begin
         
       end;
 917 : begin
         
       end;
 918 : begin
         
       end;
 919 : begin
         
       end;
 920 : begin
         
       end;
 921 : begin
         
       end;
 922 : begin
         
       end;
 923 : begin
         
       end;
 924 : begin
         
       end;
 925 : begin
         
       end;
 926 : begin
         
       end;
 927 : begin
         
       end;
 928 : begin
         
       end;
 929 : begin
         SwitchState (Normal,CharTable);
       end;
 930 : begin
         
       end;
 931 : begin
         (* AsmParse.Run_Parse; *) 
       end;
 932 : begin
         
       end;
  end;
end(*yyaction*);

(* parse table: *)

type YYARec = record
                sym, act : Integer;
              end;
     YYRRec = record
                len, sym : Integer;
              end;

const

yynacts   = 3051;
yyngotos  = 2014;
yynstates = 1248;
yynrules  = 932;

type yya_type = array [1..yynacts] of YYARec;
const yya : ^yya_type = nil;

type yyah_type = array [0..yynstates-1] of Integer;
const yyah : ^yyah_type = nil;

type yyal_type = array [0..yynstates-1] of Integer;
const yyal : ^yyal_type = nil;

type yyd_type = array [0..yynstates-1] of Integer;
const yyd : ^yyd_type = nil;

type yyg_type = array [1..yyngotos] of YYARec;
const yyg : ^yyg_type = nil;

type yygh_type = array [0..yynstates-1] of Integer;
const yygh : ^yygh_type = nil;

type yygl_type = array [0..yynstates-1] of Integer;
const yygl : ^yygl_type = nil;

type yyr_type = array [1..yynrules] of YYRRec;
const yyr : ^yyr_type = nil;

const _error = 256; (* error token *)

function yyact(state, sym : Integer; var act : Integer) : Boolean;
  (* search action table *)
  var k : Integer;
  begin
{$ifdef yyLargeTables}  {Large Tables}
   #
{$else}{$ifdef yyResourceTables}  {Tables in Ressource}
    k := yyal^[state];
    while (k<=yyah^[state]) and (yya^[k].sym<>sym) do inc(k);
    if k>yyah^[state] then
      yyact := false
    else
      begin
        act := yya^[k].act;
        yyact := true;
      end;
{$else}{$ifdef yyExternTables}  {Extern Tables}
    k := yyal^[state];
    while (k<=yyah^[state]) and (yya^[k].sym<>sym) do inc(k);
    if k>yyah^[state] then
      yyact := false
    else
      begin
        act := yya^[k].act;
        yyact := true;
      end;
{$else}  {Normal Tables}
    k := yyal[state];
    while (k<=yyah[state]) and (yya[k].sym<>sym) do inc(k);
    if k>yyah[state] then
      yyact := false
    else
      begin
        act := yya[k].act;
        yyact := true;
      end;
{$endif}{$endif}{$endif}
  end(*yyact*);

function yygoto(state, sym : Integer; var nstate : Integer) : Boolean;
  (* search goto table *)
  var k : Integer;
  begin
{$ifdef yyLargeTables}  {Large Tables}
  #
{$else}{$ifdef yyResourceTables}  {Tables in Ressource}
    k := yygl^[state];
    while (k<=yygh^[state]) and (yyg^[k].sym<>sym) do inc(k);
    if k>yygh^[state] then
      yygoto := false
    else
      begin
        nstate := yyg^[k].act;
        yygoto := true;
      end;
{$else}{$ifdef yyExternTables}  {Extern Tables}
    k := yygl^[state];
    while (k<=yygh^[state]) and (yyg^[k].sym<>sym) do inc(k);
    if k>yygh^[state] then
      yygoto := false
    else
      begin
        nstate := yyg^[k].act;
        yygoto := true;
      end;
{$else}  {Normal Tables}
    k := yygl[state];
    while (k<=yygh[state]) and (yyg[k].sym<>sym) do inc(k);
    if k>yygh[state] then
      yygoto := false
    else
      begin
        nstate := yyg[k].act;
        yygoto := true;
      end;
{$endif}{$endif}{$endif}
  end(*yygoto*);

procedure WriteAcceptedChars(state : Integer; ychar: integer);
  (* give out all possible accepted chars of that state *)
{$I all_ids.inc}
  var k, i : Integer;
      s : string;
  begin
{$ifdef yyLargeTables}  {Large Tables}
   #
{$else}{$ifdef yyResourceTables}  {Tables in Ressource}
    if kwIDlookup( s, ychar ) then
      writeln('Akt. char: ', ychar:4, ': ''', s, '''' )
    else
      writeln('Akt. char: ', ychar:4, ': None found !' );
    Writeln('Accepted chars would be:');
    k := yyal^[state];
    if k>yyah^[state] then begin
      writeln(' None found !');
  exit;
    end else begin
      i := 1;
      while k<=yyah^[state] do begin
        if kwIDlookup( s, yya^[k].sym ) then
          writeln( i:5, ' : ', yya^[k].sym:5, ': ''', s, '''' )
        else
          writeln( i:5, ' : ', yya^[k].sym:5, ': None found !' );
        inc(k); inc(i);
      end;
    end;
{$else}{$ifdef yyExternTables}  {Extern Tables}
    if kwIDlookup( s, ychar ) then
      writeln('Akt. char: ', ychar:4, ': ''', s, '''' )
    else
      writeln('Akt. char: ', ychar:4, ': None found !' );
    Writeln('Accepted chars would be:');
    k := yyal^[state];
    if k>yyah^[state] then begin
      writeln(' None found !');
  exit;
    end else begin
      i := 1;
      while k<=yyah^[state] do begin
        if kwIDlookup( s, yya^[k].sym ) then
          writeln( i:5, ' : ', yya^[k].sym:5, ': ''', s, '''' )
        else
          writeln( i:5, ' : ', yya^[k].sym:5, ': None found !' );
        inc(k); inc(i);
      end;
    end;
{$else}  {Normal Tables}
    if kwIDlookup( s, ychar ) then
      writeln('Akt. char: ', ychar:4, ': ''', s, '''' )
    else
      writeln('Akt. char: ', ychar:4, ': None found !' );
    Writeln('Accepted chars would be:');
    k := yyal[state];
    if k>yyah[state] then begin
      writeln(' None found !');
  exit;
    end else begin
      i := 1;
      while k<=yyah[state] do begin
        if kwIDlookup( s, yya^[k].sym ) then
          writeln( i:5, ' : ', yya^[k].sym:5, ': ''', s, '''' )
        else
          writeln( i:5, ' : ', yya^[k].sym:5, ': None found !' );
        inc(k); inc(i);
      end;
    end;
{$endif}{$endif}{$endif}
  end;(*WriteAcceptedChars*)

function WouldAcceptChar(sym: integer):boolean;
  var k : Integer;
  begin
{$ifdef yyLargeTables}  {Large Tables}
  #
{$else}{$ifdef yyResourceTables}  {Tables in Ressource}
    k := yyal^[yystate];
    while (k<=yyah^[yystate]) and (yya^[k].sym<>sym) do inc(k);
    if k>yyah^[yystate] then
       WouldAcceptChar:= false
    else
      WouldAcceptChar := true;
{$else}{$ifdef yyExternTables}  {Extern Tables}
    k := yyal^[yystate];
    while (k<=yyah^[yystate]) and (yya^[k].sym<>sym) do inc(k);
    if k>yyah^[yystate] then
       WouldAcceptChar:= false
    else
      WouldAcceptChar := true;
{$else}  {Normal Tables}
    k := yyal[yystate];
    while (k<=yyah[yystate]) and (yya[k].sym<>sym) do inc(k);
    if k>yyah[yystate] then
       WouldAcceptChar:= false
    else
      WouldAcceptChar := true;
{$endif}{$endif}{$endif}
  end;(*WouldAcceptChar*)

procedure AllocateStacks;
begin
  New( yys ); New( yyv );
end;

procedure DeallocateStacks;
begin
  if yys <> nil then Dispose( yys ); yys := nil;
  if yyv <> nil then Dispose( yyv ); yyv := nil;
end;

{$ifdef yyLargeTables}  {Large Tables}
  #
{$else}{$ifdef yyResourceTables}  {Tables in Ressource}
type TTables = ( t_yya, t_yyg, t_yyd, t_yyal, t_yyah, t_yygl, t_yygh, t_yyr );
const TableNames : array[TTables] of string[9] =
                          ( 'YYA_DAT'+#0, 'YYG_DAT'+#0, 'YYD_DAT'+#0, 'YYAL_DAT'+#0,
                            'YYAH_DAT'+#0, 'YYGL_DAT'+#0, 'YYGH_DAT'+#0, 'YYR_DAT'+#0 );
var TableHandles : array[TTables] of THandle;
procedure AllocateTables;
{Resource laden: FindResource, LoadResource, LockResource}
var i : TTables;
    t : THandle;
begin {proc AllocateTables}
  AllocateStacks;
  for i := Low(TTables) to High(TTables) do begin
    t := FindResource( HInstance{or: GetCurrentTask}, @(TableNames[i][1]), RT_RCDATA );
    TableHandles[i] := LoadResource( HInstance{or: GetCurrentTask}, t );
    if TableHandles[i] = 0 then
      raise EReadError.Create('AllocateTables: Konnte Ressource nicht laden: ' +
      TableNames[i] + ' !' );
  end;
  yya := LockResource( TableHandles[t_yya] );
  yyg := LockResource( TableHandles[t_yyg] );
  yyd := LockResource( TableHandles[t_yyd] );
  yyal := LockResource( TableHandles[t_yyal] );
  yyah := LockResource( TableHandles[t_yyah] );
  yygl := LockResource( TableHandles[t_yygl] );
  yygh := LockResource( TableHandles[t_yygh] );
  yyr := LockResource( TableHandles[t_yyr] );
end; {proc AllocateTables}

procedure DeallocateTables;
var i : TTables;
begin
  try
    DeallocateStacks;
  finally
    for i := Low(TTables) to High(TTables) do begin
      UnlockResource( TableHandles[i] );
      FreeResource( TableHandles[i] );
    end;
  end;
end; {proc DeallocateTables}
{$else}{$ifdef yyExternTables}  {Extern Tables}
procedure AllocateTables;

  function LoadFromFile( var Dest; Count: Word; const FileName: string ): pointer;
  {vorher mit  GetMem( R, Size ); den Speicherbereich allozieren}
  var thelp : TMemoryStream;
      f : file of byte;
  begin
    Result := nil;
    thelp := TMemoryStream.Create;
    try
      {FileSize ermitteln}
      AssignFile( f, FileName );
      Reset( f );
      thelp.SetSize( FileSize( f ) );
      CloseFile( f );
      {Gre berprfen}
      if Count <> thelp.Size then
        raise EReadError.Create('LoadFromFile: Gren passen nicht zusammen !' + #13 +
         'Erwartet: ' + IntToStr( Count ) + ' - bekommen in ' + FileName + ' : ' +
         IntToStr(thelp.Size) );
      {File in den TMemoryStream laden}
      thelp.LoadFromFile( FileName );
      {File in den Speicher kopieren}
      move( thelp.Memory^ , Dest, thelp.Size );
    finally
      {TMemoryStream lschen}
      thelp.SetSize( 0 );
      thelp.Free;
    end;
    Result := @Dest;
  end; {func LoadFromFile}

  var Path : string;
begin {proc AllocateTables}
  AllocateStacks;
  Path := ExtractFilePath(Application.ExeName);
  {Tabelle: yya} new( yya ); LoadFromFile( yya^, SizeOf( yya^ ), Path+'yya.dat');
  {Tabelle: yyg} new( yyg ); LoadFromFile( yyg^, SizeOf( yyg^ ), Path+'yyg.dat');
  {Tabelle: yyd} new( yyd ); LoadFromFile( yyd^, SizeOf( yyd^ ), Path+'yyd.dat');
  {Tabelle: yyal}new( yyal ); LoadFromFile( yyal^, SizeOf( yyal^ ), Path+'yyal.dat');
  {Tabelle: yyah}new( yyah ); LoadFromFile( yyah^, SizeOf( yyah^ ), Path+'yyah.dat');
  {Tabelle: yygl}new( yygl ); LoadFromFile( yygl^, SizeOf( yygl^ ), Path+'yygl.dat');
  {Tabelle: yygh}new( yygh ); LoadFromFile( yygh^, SizeOf( yygh^ ), Path+'yygh.dat');
  {Tabelle: yyr} new( yyr ); LoadFromFile( yyr^, SizeOf( yyr^ ), Path+'yyr.dat');
end; {proc AllocateTables}

procedure DeallocateTables;
begin
  try
    DeallocateStacks;
  finally
    if yya <> nil then Dispose( yya ); yya := nil;
    if yyg <> nil then Dispose( yyg ); yyg := nil;
    if yyd <> nil then Dispose( yyd ); yyd := nil;
    if yyal <> nil then Dispose( yyal ); yyal := nil;
    if yyah <> nil then Dispose( yyah ); yyah := nil;
    if yygl <> nil then Dispose( yygl ); yygl := nil;
    if yygh <> nil then Dispose( yygh ); yygh := nil;
    if yyr <> nil then Dispose( yyr ); yyr := nil;
  end;
end; {proc DeallocateTables}
{$else}  {Normal Tables}
procedure AllocateTables;
begin
  AllocateStacks;
end;

procedure DeallocateTables;
begin
  DeallocateStacks;
end;
{$endif}{$endif}{$endif}

function yyparse : Integer;

label parse, next, error, errlab, shift, reduce, accept, abort;

begin(*yyparse*)

  try

{$ifdef yyLargeTables}  {Large Tables}
  #
{$else}{$ifdef yyResourceTables}  {Tables in Ressource}
    AllocateTables;
{$else}{$ifdef yyExternTables}  {Extern Tables}
    AllocateTables;
{$else}  {Normal Tables}
    AllocateTables;
{$endif}{$endif}{$endif}

    (* initialize: *)
    yystate := 0; yychar := -1; yynerrs := 0; yyerrflag := 0; yysp := 0;

    {$ifdef yydebug}
      yydebug := true;
    {$else}
      yydebug := false;
    {$endif}

parse:

    (* push state and value: *)

    inc(yysp);
    if yysp>yymaxdepth then
      begin
        yyerror('yyparse stack overflow');
        goto abort;
      end;
    yys^[yysp] := yystate; yyv^[yysp] := yyval;

next:

{$ifdef yyLargeTables}  {Large Tables}
  #
{$else}{$ifdef yyResourceTables}  {Tables in Ressource}
    if (yyd^[yystate]=0) and (yychar=-1) then
{$else}{$ifdef yyExternTables}  {Extern Tables}
    if (yyd^[yystate]=0) and (yychar=-1) then
{$else}  {Normal Tables}
    if (yyd[yystate]=0) and (yychar=-1) then
{$endif}{$endif}{$endif}

      (* get next symbol *)
      begin
        yychar := yylex; if yychar<0 then yychar := 0;
      end;

    {$ifdef yydebug}
    if yydebug then writeln('state ', yystate, ', char ', yychar);
    {$endif}

    (* determine parse action: *)

{$ifdef yyLargeTables}  {Large Tables}
  #
{$else}{$ifdef yyResourceTables}  {Tables in Ressource}
    yyn := yyd^[yystate];
{$else}{$ifdef yyExternTables}  {Extern Tables}
    yyn := yyd^[yystate];
{$else}  {Normal Tables}
    yyn := yyd[yystate];
{$endif}{$endif}{$endif}
    if yyn<>0 then goto reduce; (* simple state *)

    (* no default action; search parse table *)

    if not yyact(yystate, yychar, yyn) then goto error
    else if yyn>0 then                      goto shift
    else if yyn<0 then                      goto reduce
    else                                    goto accept;

error:

    (* error; start error recovery: *)

    if yyerrflag=0 then begin
      yyerror('syntax error');
      {$ifdef ErrorRecovery}
      WriteAcceptedChars(yystate,yychar);
      {$endif}
    end;

errlab:

    if yyerrflag=0 then inc(yynerrs);     (* new error *)

    if yyerrflag<=2 then                  (* incomplete recovery; try again *)
      begin
        yyerrflag := 3;
        (* uncover a state with shift action on error token *)
        while (yysp>0) and not ( yyact(yys^[yysp], _error, yyn) and
                                 (yyn>0) ) do
          begin
            {$ifdef yydebug}
            if yydebug then
              if yysp>1 then
                writeln('error recovery pops state ', yys^[yysp], ', uncovers ',
                        yys^[yysp-1])
              else
                writeln('error recovery fails ... abort');
            {$endif}
            dec(yysp);
          end;
        if yysp=0 then goto abort; (* parser has fallen from stack; abort *)
        yystate := yyn;            (* simulate shift on error *)
        goto parse;
      end
    else                                  (* no shift yet; discard symbol *)
      begin
        {$ifdef yydebug}
        if yydebug then writeln('error recovery discards char ', yychar);
        {$endif}
        if yychar=0 then goto abort; (* end of input; abort *)
        yychar := -1; goto next;     (* clear lookahead char and try again *)
      end;

shift:

    (* go to new state, clear lookahead character: *)

    yystate := yyn; yychar := -1; yyval := yylval;
    if yyerrflag>0 then dec(yyerrflag);

    goto parse;

reduce:

    (* execute action, pop rule from stack, and go to next state: *)

    {$ifdef yydebug}
    if yydebug then writeln('reduce ', -yyn);
    {$endif}

    yyflag := yyfnone; yyaction(-yyn);
{$ifdef yyLargeTables}  {Large Tables}
  #
{$else}{$ifdef yyResourceTables}  {Tables in Ressource}
    dec(yysp, yyr^[-yyn].len );
    if yygoto( yys^[yysp],  yyr^[-yyn].sym, yyn ) then yystate := yyn;
{$else}{$ifdef yyExternTables}  {Extern Tables}
    dec(yysp, yyr^[-yyn].len );
    if yygoto( yys^[yysp],  yyr^[-yyn].sym, yyn ) then yystate := yyn;
{$else}  {Normal Tables}
    dec(yysp, yyr[-yyn].len );
    if yygoto( yys^[yysp], yyr[-yyn].sym, yyn ) then yystate := yyn;
{$endif}{$endif}{$endif}

    (* handle action calls to yyaccept, yyabort and yyerror: *)

    case yyflag of
      yyfaccept : goto accept;
      yyfabort  : goto abort;
      yyferror  : goto errlab;
    end;

    goto parse;

accept:

    yyparse := 0; DeallocateTables; exit;

abort:

    yyparse := 1; DeallocateTables; exit;

  finally

{$ifdef yyLargeTables}  {Large Tables}
  #
{$else}{$ifdef yyResourceTables}  {Tables in Ressource}
    DeallocateTables;
{$else}{$ifdef yyExternTables}  {Extern Tables}
    DeallocateTables;
{$else}  {Normal Tables}
    DeallocateTables;
{$endif}{$endif}{$endif}

  end;

end(*yyparse*);



type TBuf = array[1..10240] of char;
var Buf : ^TBuf;


procedure Run_Parse;
begin
  filename := paramStr(1);
  if filename='' then
    begin
      write('input file: ');
      readln(filename);
    end;
  assign(yyinput, filename);
  reset(yyinput);

  New( Buf );
  SetTextBuf( yyinput, Buf );

  if yyparse=0 then writeln('successful parse!');

  Flush(yyoutput);

end;

begin
end.